/*! 
  @file rx_bitmap.h
	
  @brief rbg}bvt@Cǂݍ݁Co
	- http://ja.wikipedia.org/wiki/Windows_bitmap

	- OS/2(V1), Windows(V3,V4,V5)̔񈳏krbg}bvɑΉ
	- rbgtB[htrbg}bvCJ[pbgtrbg}bvɑΉ

	- RLE, JPEG, PNGk͖Ή
	- V4,V5̃J[}lWgCvt@Cɂ͖Ή
 
  @author Makoto Fujisawa
  @date 2011-06
  @update 2016-02
*/


#ifndef _RX_BITMAP_H_
#define _RX_BITMAP_H_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include <cstdio>

#include <vector>
#include <string>


//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
enum rxBitmapType
{
	RX_BMP_OS2_V1, 
	RX_BMP_OS2_V2, 
	RX_BMP_WINDOWS_V3, 
	RX_BMP_WINDOWS_V4, 
	RX_BMP_WINDOWS_V5, 
};

//-----------------------------------------------------------------------------
// \
//-----------------------------------------------------------------------------
//! ICM(Image Color Management)` (36rbg,CIEXYZTRIPLE^Ɠ)
//  - http://www.adobe.com/jp/support/techguides/color/colormodels/ciexyz.html
struct rxICMColor
{
	long red[3];	//!< Rpx,y,z
	long green[3];	//!< Gpx,y,z
	long blue[3];	//!< Bpx,y,z
};

//! J[pbgpRGB\
struct rxBmpRGB
{
	unsigned char r, g, b;	//!< ԁC΁C
};

//! J[pbgpRGB\(\̈܂)
struct rxBmpRGB4
{
	unsigned char r, g, b;	//!< ԁC΁C
	unsigned char res;		//!< \̈
};

//! t@Cwb_ (14oCg-2oCg)
// - http://msdn.microsoft.com/en-us/library/dd183374(VS.85).aspx
struct rxBmpFileHeader
{
	//char type[2];			//!< t@C^Cv(2oCg) - BMPȂ'B''M'
	unsigned int size;		//!< t@CTCY(4oCg)
	char reserved[4];		//!< \̈1,2(2oCg x 2)
	unsigned int offset;	//!< C[Wf[^܂ł̃ItZbg(4oCg) - INFOȂ54
};

//! wb_(CORE^Cv(OS/2),12oCg)
// - http://msdn.microsoft.com/en-us/library/dd183372(VS.85).aspx
struct rxBmpInfoHeaderOS2
{
	unsigned int size;			//!< wb_TCY(4oCg) - 12oCg
	unsigned short width;		//!< 摜̕(2oCg) - sNZ,1ȏ
	unsigned short height;		//!< 摜̍(2oCg) - sNZ,1ȏ
	unsigned short planes;		//!< 摜̃`l(2oCg) - 1
	unsigned short bitcount;	//!< rbg/sNZ(2oCg) - 1,4,8,24
};

//! wb_(INFO,V4,V5^Cv(Windows),40,108,124oCg)
// - INFO : http://msdn.microsoft.com/en-us/library/dd183376(v=VS.85).aspx
// - V4   : http://msdn.microsoft.com/en-us/library/dd183380(VS.85).aspx
// - V5   : http://msdn.microsoft.com/en-us/library/dd183381(VS.85).aspx
struct rxBmpInfoHeaderWin
{
	unsigned int size;			//!< wb_TCY(4oCg) - 40,108,124oCg
	int width;					//!< 摜̕(4oCg) - sNZ,1ȏ
	int height;					//!< 摜̍(4oCg) - sNZ,0ȊO,}CiX̏ꍇ̓gbv_E`
	unsigned short planes;		//!< 摜̃`l(2oCg) - 1
	unsigned short bitcount;	//!< rbg/sNZ(2oCg) - 0,1,4,8,16,24,32
	unsigned int compression;	//!< k`(4oCg) - 0(񈳏k), 1(8rbgRLE), 2(4rbgRLE), 3(rbgtB[ht񈳏k), 4(JPEG), 5(PNG)
	unsigned int image_size;	//!< 摜f[^̃TCY(4oCg) - oCg
	unsigned int xpixel;		//!< 𑜓x(4oCg) - sNZ/[g
	unsigned int ypixel;		//!< 𑜓x(4oCg) - sNZ/[g
	unsigned int num_color_idx;		//!< gpF(4oCg) - J[pbgɊi[F
	unsigned int num_important_idx;	//!< dvȐF(4oCg) - J[pbg̏dvF̐(\ɕKvȐ)

	// V4,V5^Cvp
	unsigned int red_mask;		//!< Ԑ̃J[}XN(4oCg)
	unsigned int green_mask;	//!< ΐ̃J[}XN(4oCg)
	unsigned int blue_mask;		//!< ̃J[}XN(4oCg)
	unsigned int alpha_mask;	//!< At@̃J[}XN(4oCg)
	unsigned int color_space;	//!< F(4oCg) - 0
	rxICMColor icm;				//!< CIE XYZ(36oCg)
	//CIEXYZTRIPLE icm;
	unsigned int red_gamma;		//!< Ԑ̃K}l(4oCg)
	unsigned int green_gamma;	//!< ΐ̃K}l(4oCg)
	unsigned int blue_gamma;	//!< ̃K}l(4oCg)

	// V5^Cvp
	unsigned int intent;		//!< sRGBFԃ^Cv(4oCg) - ICC32 : 1(Saturation),2(Relative Colorimetric),4(Perceptual),8(Absolute Colorimetic)
	unsigned int profile_data;	//!< vt@Cf[^̃ItZbg(4oCg) - wb_̐擪̃ItZbgoCg
	unsigned int profile_size;	//!< vt@Cf[^̃TCY(4oCg) - oCg
	unsigned int reserved;		//!< \̈(4oCg) - 0
};

//! rbgtB[h(12oCg)
// - INFO^Cvbitcount1632Ccompression3̏ꍇɏwb_̒ɑ
struct rxBmpBitField
{
	unsigned int red_mask;		//!< Ԑ̃J[}XN(4oCg)
	unsigned int green_mask;	//!< ΐ̃J[}XN(4oCg)
	unsigned int blue_mask;		//!< ̃J[}XN(4oCg)
};


//-----------------------------------------------------------------------------
// Œ菬_̕ϊ֐(K}lp)
//-----------------------------------------------------------------------------
/*!
 * _(float)Œ菬_ւ̕ϊ
 *  - K}li[p
 *  - 8.8Œ菬_
 *  - 9`16rbg
 * @param[in] x _
 * @param[in] shift Œ菬_̏
 * @return Œ菬_
 */
inline int FloatToFixForGamma(float x)
{
	int power = 1 << 16;
	return (int)(power*x) & 0x00ffff00;
}

/*!
 * Œ菬_畂_(float)ւ̕ϊ
 * @param[in] x Œ菬_
 * @param[in] shift Œ菬_̏
 * @return _
 */
inline float FixToFloatForGamma(int x)
{
	int power = 1 << 16;
	return (float)x/(float)power;
}


//-----------------------------------------------------------------------------
// BMPt@C̓ǂݍ݂Ə
//-----------------------------------------------------------------------------
/*!
 * BMPt@C̓ǂݍ
 * @param[in] fn t@C
 * @param[out] w,h 摜TCY
 * @param[out] c 摜̐F[x
 * @param[in] use_bmp_w rbg}bv̐oCg((((w+1)*c)/4)*4)ۂ
 * @param[in] h_inv ̃sNZ]tO(default=true)
 * @param[in] bgr_inv BGR->RGBϊtO(default=true)
 * @return 摜f[^
 */
static unsigned char* ReadBitmapFile(const std::string &fn, int &w, int &h, int &c, int &wstep, 
									 bool h_inv = true, bool bgr_inv = true)
{
	// t@CoCi[hŊJ
	FILE *fp;
	if((fp = fopen(fn.c_str(), "rb")) == NULL){
		fprintf(stderr, "bitmap error : cannot open %s file\n", fn.c_str());
		return 0;
	}

	//fseek(fp, 0L, SEEK_SET);

	// t@Cwb_̓ǂݍ
	char type[2];
	rxBmpFileHeader file_header;
	fread(type, sizeof(char), 2, fp);						// 2oCg
	fread(&file_header, sizeof(file_header), 1, fp);		// 12oCg

	// wb_TCY̓ǂݍ
	unsigned int info_header_size = 0;
	fread(&info_header_size, sizeof(unsigned int), 1, fp);	// 4oCg
	fseek(fp, (long)(sizeof(char)*14), SEEK_SET);

	int bitcount = 0;	// sNZrbg
	
	std::vector<rxBmpRGB4> cpalette;	// J[pbg
	bool use_cmask = false;		// J[}XNgptO
	unsigned int cmask[4] = {0x000000ff, 0x0000ff00, 0x00ff0000, 0xff000000};	// J[}XN(RGBA)
	int cmask_shift = 0;		// J[}XÑrbg

	// wb_̓ǂݍ
	if(info_header_size == 12 || info_header_size == 64){	// OS/2
		//printf("OS/2\n");
		rxBmpInfoHeaderOS2 info_header;
		fread(&info_header, sizeof(char), info_header_size, fp);

		w = (int)info_header.width;
		h = (int)info_header.height;
		c = (int)ceil((double)info_header.bitcount/8.0);
		bitcount = (int)info_header.bitcount;

		// J[pbg
		if(bitcount <= 8){
			std::vector<rxBmpRGB> cpalette3;
			int n = 1 << bitcount;
			cpalette3.resize(n);
			fread(&cpalette3[0], sizeof(rxBmpRGB), n, fp);

			cpalette.resize(n);
			for(int i = 0; i < n; ++i){
				cpalette[i].r = cpalette3[i].r;
				cpalette[i].g = cpalette3[i].g;
				cpalette[i].b = cpalette3[i].b;
				cpalette[i].res = 0;
			}
		}
	}
	else if(info_header_size >= 40){	// Windows
		//printf("Windows\n");
		rxBmpInfoHeaderWin info_header;
		fread(&info_header, sizeof(char), info_header_size, fp);	

		w = (int)info_header.width;
		h = (int)info_header.height;
		c = (int)ceil((double)info_header.bitcount/8.0);
		bitcount = (int)info_header.bitcount;

		// rbgtB[h
		if(info_header.compression == 3 && (bitcount == 16 || bitcount == 32)){
			// }XNl߂
			use_cmask = true;
			if(info_header_size == 40){
				fread(cmask, sizeof(unsigned int), 3, fp);
			}
			else{
				cmask[0] = info_header.red_mask;
				cmask[1] = info_header.green_mask;
				cmask[2] = info_header.blue_mask;
				cmask[3] = info_header.alpha_mask;
			}
			// }XÑrbg(̃}XN1̃rbg̐𐔂)
			cmask_shift = (int)(log((double)(cmask[2]+1))/log(2.0));
		}

		// J[pbg
		if(bitcount >= 1 && bitcount <= 8 && info_header.num_color_idx){
			std::vector<rxBmpRGB4> cpalette;
			int n = info_header.num_color_idx;
			cpalette.resize(n);
			fread(&cpalette[0], sizeof(rxBmpRGB4), n, fp);
		}
	}
	else{
		fclose(fp);
		return 0;
	}

	wstep = (((w+1)*c)/4)*4;	// rbg}bv̐(XLC)̃oCg4̔{(]Ƃ0x00Ŗ߂)

	if(h < 0){
		// gbv_E`(摜ォ牺֋L^)̏ꍇ
		h = -h;
	}
	
	if(!cpalette.empty() || use_cmask){
		c = 3;
	}

	// ǂݍ݂̂߂̈ꎞۑobt@(̃oCg4̔{)
	unsigned char* img_buf = new unsigned char[wstep*h];

	if(!cpalette.empty()){
		// f[^擾āCJ[pbgKC摜f[^쐬
		int bitmask = (1 << bitcount)-1;
		int div = 8/bitcount;

		int m = (w*h)/div;	// esNZ̃rbg8rbg(1oCg)ƂƂ̑sNZ
		unsigned char* bit_buf = new unsigned char[m];
		fread(bit_buf, sizeof(unsigned char), (size_t)(long)(m), fp);

		unsigned char* buf = bit_buf;
		for(int i = 0; i < m; ++i){
			unsigned char b = *buf;
			for(int j = 0; j < div; ++j){
				int k = (b >> bitcount*(div-j-1)) & bitmask;
				rxBmpRGB4 c = cpalette[k];
				int idx = 3*(div*i+j);
				img_buf[idx+0] = c.r;
				img_buf[idx+1] = c.g;
				img_buf[idx+2] = c.b;
			}
			buf++;
		}

		free(bit_buf);
	}
	else if(use_cmask){
		// f[^擾āCrbgtB[hKpC摜f[^쐬
		// bitcount1632
		int bitmask = (bitcount == 16 ? 0x0000ffff : 0xffffffff);
		int div = 32/bitcount;
		int m = (w*h)/div;	// esNZ̃rbg32rbg(4oCg)ƂƂ̑sNZ
		unsigned int* bit_buf = new unsigned int[m];
		fread(bit_buf, sizeof(unsigned int), (size_t)(long)(m), fp);

		unsigned int* buf = bit_buf;
		for(int i = 0; i < m; ++i){
			unsigned int b = *buf;
			for(int j = 0; j < div; ++j){
				unsigned int c = (b >> bitcount*(div-j-1)) & bitmask;
				int idx = 3*(div*i+j);
				img_buf[idx+0] = (cmask[0] & c) >> cmask_shift*2;
				img_buf[idx+1] = (cmask[1] & c) >> cmask_shift;
				img_buf[idx+2] = (cmask[2] & c);

			}

			buf++;
		}

		free(bit_buf);
	}
	else{
		// 摜f[^̎擾
		fread(img_buf, sizeof(unsigned char), (size_t)(long)(wstep*h), fp);
	}

	// o̓f[^
	unsigned char* img = new unsigned char[wstep*h];

	// 摜f[^
	int c0 = bgr_inv ? 2 : 0;
	int c2 = bgr_inv ? 0 : 2;
	// BGR -> RGB  ㉺] Ȃf[^Rs[
	for(int j = 0; j < h; ++j){
		for(int i = 0; i < w; ++i){
			int idx0 = c*i+j*wstep;
			int idx1 = h_inv ? c*i+(h-j-1)*wstep : c*i+j*wstep;
			img[idx0+0] = img_buf[idx1+c0];
			img[idx0+1] = img_buf[idx1+1];
			img[idx0+2] = img_buf[idx1+c2];
		}
		for(int i = w*c; i < wstep; ++i){
			img[i+j*wstep] = 0x00;
		}
	}

	delete [] img_buf;
	fclose(fp);
	return img;
}

/*!
 * BMPt@C̏(INFO^Cv)
 * @param[in] fn t@C
 * @param[in] img 摜f[^
 * @param[in] w,h 摜TCY
 * @param[in] c 摜̐F[x
 * @param[in] iwstep ͉摜f[^̐̃oCg(rbg}bvȂ(((w+1)*c)/4)*4
 * @param[in] type rbg}bv`(default=RX_BMP_WINDOWS_V3)
 * @param[in] h_inv ̃sNZ]tO(default=true)
 * @param[in] bgr_inv RGB->BGRϊtO(default=true)
 */
static int WriteBitmapFile(const std::string &fn, unsigned char *img, int w, int h, int c, int type = RX_BMP_WINDOWS_V3, 
						   int iwstep = -1, bool h_inv = true, bool bgr_inv = true)
{
	// t@CoCi[hŊJ
	FILE *fp;
	if((fp = fopen(fn.c_str(), "wb")) == NULL){
		fprintf(stderr, "bitmap error : cannot open %s file\n", fn.c_str());
		return 0;
	}

	if(iwstep <= 0) iwstep = w*c;

	// t@Cwb_
	char file_type[2] = {'B', 'M'};
	fwrite(file_type, sizeof(char), 2, fp);

	rxBmpFileHeader file_header;
	file_header.size = w*h*c+54;
	file_header.reserved[0] = 0;
	file_header.reserved[1] = 0;
	file_header.reserved[2] = 0;
	file_header.reserved[3] = 0;
	file_header.offset = 54;

	fwrite(&file_header, sizeof(file_header), 1, fp);

	if(type == RX_BMP_OS2_V1 || type == RX_BMP_OS2_V2){
		// wb_(OS/2)
		rxBmpInfoHeaderOS2 info_header;
		info_header.size = 12;
		info_header.width = (unsigned short)w;
		info_header.height = (unsigned short)h;
		info_header.planes = 1;
		info_header.bitcount = 8*c;

		fwrite(&info_header, sizeof(info_header), 1, fp);	// 12oCg
	}
	else if(type >= RX_BMP_WINDOWS_V3){
		// wb_(Windows)
		rxBmpInfoHeaderWin info_header;
		info_header.width = w;
		info_header.height = h;
		info_header.planes = 1;
		info_header.bitcount = 8*c;
		info_header.compression = 0;	// 񈳏k
		info_header.image_size = w*h*c;
		info_header.xpixel = 0;
		info_header.ypixel = 0;
		info_header.num_color_idx = 0;
		info_header.num_important_idx = 0;

		if(type == RX_BMP_WINDOWS_V3){
			info_header.size = 40;
		}
		else if(type >= RX_BMP_WINDOWS_V4){
			info_header.size = 108;

			// J[}XN
			info_header.red_mask   = 0xff0000;
			info_header.green_mask = 0x00ff00;	
			info_header.blue_mask  = 0x0000ff;	
			info_header.alpha_mask = 0x000000;	

			// F
			info_header.color_space = 0;

			// ICM
			rxICMColor icm;
			icm.red[0] = icm.red[1] = icm.red[2] = 0;
			icm.green[0] = icm.green[1] = icm.green[2] = 0;
			icm.blue[0] = icm.blue[1] = icm.blue[2] = 0;
			info_header.icm = icm;

			// K}l
			float gamma = 1.1f;
			info_header.red_gamma = FloatToFixForGamma(gamma);
			info_header.green_gamma = FloatToFixForGamma(gamma);
			info_header.blue_gamma = FloatToFixForGamma(gamma);

			if(type == RX_BMP_WINDOWS_V5){
				info_header.size = 124;

				// V5^Cvp
				info_header.intent = 1;
				info_header.profile_data = 0;
				info_header.profile_size = 0;
				info_header.reserved = 0;
			}
		}
		
		fwrite(&info_header, sizeof(char), info_header.size, fp);
	}
	else{
		return 0;
	}


	// 摜f[^
	int wstep = (((w+1)*c)/4)*4;	// rbg}bv̐(XLC)̃oCg4̔{(]Ƃ0x00Ŗ߂)
	unsigned char *img_buf = new unsigned char[wstep*h];
	int c0 = bgr_inv ? 2 : 0;
	int c2 = bgr_inv ? 0 : 2;
	// RGB -> BGR  ㉺]
	for(int j = 0; j < h; ++j){
		for(int i = 0; i < w; ++i){
			int idx0 = c*i+j*wstep;
			int idx1 = h_inv ? c*i+(h-j-1)*iwstep : c*i+j*iwstep;
			img_buf[idx0+0] = img[idx1+c0];
			img_buf[idx0+1] = img[idx1+1];
			img_buf[idx0+2] = img[idx1+c2];
		}
		for(int i = w*c; i < wstep; ++i){
			img_buf[i+j*wstep] = 0x00;
		}
	}

	fwrite(img_buf, sizeof(unsigned char), (size_t)(long)(wstep*h), fp);
	delete [] img_buf;

	fclose(fp);

	return 1;
}


#endif // #ifndef _RX_BITMAP_H_
